.586
.model flat, stdcall
option casemap :none

      include		\masm32\include\windows.inc
      include		\masm32\include\kernel32.inc
      include		\masm32\include\user32.inc
      include		\masm32\include\masm32.inc
      include 		\masm32\include\debug.inc
      
      includelib 	\masm32\lib\kernel32.lib
      includelib 	\masm32\lib\user32.lib
      includelib 	\masm32\lib\masm32.lib
      includelib 	\masm32\lib\debug.lib
      
      
      include		\masm32\oop\objects.inc
      
     
      include		NNet.asm
      
      OutputResults	PROTO	STDCALL

.data?
	hInstance	dd	?
	
	lpXorNet	dd	?
.data
	
	input00		REAL4	0.0, 0.0
	input01		REAL4	0.0, 1.0
	input10		REAL4	1.0, 0.0
	input11		REAL4	1.1, 1.1
	
	output0		REAL4	0.0
	output1		REAL4	1.0

	r4_100		REAL4	100.0

	XorNetInfo	NNINFO	<2,\		;inputs
						 1,\		;outpus
						 1,\		;hidden layers
						 2>			;neurons in hidden layer


.code
start:

    invoke 	GetModuleHandle, NULL
    mov 	hInstance, eax
	PrintText	"---neural network XOR demo, output values are percentages---"
	newobject 	NNet, offset XorNetInfo
	mov			lpXorNet, eax
	
	method		eax, NNet, initRandom
	
	PrintText 	"---outputs before training---"
	invoke		OutputResults
	
	xor		ebx, ebx
	.WHILE	ebx<2000		;train 2000 times
		method	lpXorNet, NNet, train, addr input00, addr output0
		method	lpXorNet, NNet, train, addr input01, addr output1
		method	lpXorNet, NNet, train, addr input11, addr output0
		method	lpXorNet, NNet, train, addr input10, addr output1
		
	inc		ebx
	.ENDW
		
	PrintText 	"---outputs after training---"
	invoke		OutputResults
	
	

    invoke ExitProcess,eax



OutputResults	proc
LOCAL	outputValue:DWORD
	PrintText "0 xor 0:"
	method lpXorNet, NNet, run, addr input00
	fld		 real4 ptr [eax] ;first (and only) output
	fmul	 r4_100
	fistp	 outputValue
	PrintDec outputValue
	
	PrintText "0 xor 1:"
	method lpXorNet, NNet, run, addr input01
	fld		 real4 ptr [eax] ;first (and only) output
	fmul	 r4_100
	fistp	 outputValue
	PrintDec outputValue
	
	
	PrintText "1 xor 0:"
	method lpXorNet, NNet, run, addr input10
	fld		 real4 ptr [eax] ;first (and only) output
	fmul	 r4_100
	fistp	 outputValue
	PrintDec outputValue
	
	PrintText "1 xor 1:"
	method lpXorNet, NNet, run, addr input11
	fld		 real4 ptr [eax] ;first (and only) output
	fmul	 r4_100
	fistp	 outputValue
	PrintDec outputValue
	
ret
OutputResults	endp


end start